题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5406
#include<bits/stdc++.h>
#pragma comment(linker,"/STACK:1024000000,1024000000")
using namespace std;#define debug puts("YES");
#define rep(x,y,z) for(int (x)=(y);(x)<(z);(x)++)
#define read(x,y) scanf("%d%d",&x,&y)#define lrt int l,int r,int rt
#define lson l,mid,rt<<1
#define rson mid+1,r,rt<<1|1
#define ll long long
const int maxn =1e3+5;
const int mod=1e9+7;
ll powmod(ll x,ll y) {ll t;for(t=1;y;y>>=1,x=x*x%mod) if(y&1) t=t*x%mod;return t;}
ll gcd(ll x,ll y) { return y==0?x:gcd(y,x%y); }
/*
题目大意:很简单,最终要求是给定一个序列
求两个不重叠不降子序列的最大长度。分析一下里面的DP性质,
dp[i][c]=dp[c][i]=max{dp[i][j]|j<c}。
然后考虑用树状数组维护极值,
树状数组开二维但不用二维统计。
分析下,如果一个数加进来,整体状态会有怎样的变化?
dp[i]=max{tree[i][j]|j<v+1}其中v是新加进来的值,
再用新得到的DP值去贡献未来的tree值,
但要注意的是要先求最新,再更新,不然可能答案被覆盖。因为对称性,tree[i][c]=tree[c][i],所以更新要更新两次。这道题思路还是比较难的感觉,,,花了我好长时间才搞懂,
可能是对DP还是掌握的不够吧。。。*/
///树状数组维护极值
int tree[maxn][maxn];
int lowbit(int x) { return x&(-x); }
void add(int *f,int x,int d) { for(;x<maxn;f[x]=max(f[x],d),x+=lowbit(x)); }
int sum(int *f,int x){ int ret=0; for(;x>0;ret=max(ret,f[x]),x-=lowbit(x)); return ret; }
///离散化
struct node
{int h,d;bool operator<(const node& y)const{if(y.h==h) return d<y.d;return h>y.h;}
}p[maxn];///节点数组
int n,top;
int ans,dat[maxn];
void init()
{memset(tree,0,sizeof(tree));ans=0;scanf("%d",&n);for(int i=0;i<n;i++){scanf("%d%d",&p[i].h,&p[i].d);dat[i]=p[i].d;}sort(p,p+n);sort(dat,dat+n);top=1;for(int i=1;i<n;i++){if(dat[i]==dat[i-1]) continue;dat[top++]=dat[i];}///top=unique(dat,dat+n)-dat+1;///离散化for(int i=0;i<n;i++) p[i].d=lower_bound(dat,dat+top,p[i].d)-dat+1;///加一为了方便树状数组结构
}
///解决主体
int solve()
{int ret=0,dp[maxn];///滚动数组for(int i=0;i<n;i++){int v=p[i].d;for(int j=0;j<=top;j++)dp[j]=sum(tree[j],v)+1;///统计把i位置的数加进去产生的最优解for(int j=0;j<=top;j++){ans=max(ans,dp[j]);add(tree[j],v+1,dp[j]);///贡献思维,更新答案add(tree[v],j+1,dp[j]);}}return ans;
}
int main()
{int t; scanf("%d",&t);while(t--){init();printf("%d\n",solve());}return 0;
}